macroScript CameraLister category:"Frodo's Magic Bag"
(
	
rcmenu CLmenu (
	menuItem helpBtn "Help"

on helpBtn picked do (
createDialog help
)

)
	
rollout CameraLister "Camera Lister v3.2" width:200 height:275
(
	listBox sceneCams ""  width:190 height:20 align:#center
	
on CameraLister resized sel do(
	sceneCams.width = (CameraLister.width-10)
	sceneCams.height = (CameraLister.height-10)
)

fn selLocked = (
selectionlock = false
sel = selection as array
clearselection()
if selection.count != 0 then selectionlock = true else selectionlock = false
select sel
selectionlock
    )
	
fn getCams = (
	sceneCams.items = sort (for c in cameras where (isKindOf c camera) collect c.name)
	)
	
-----------------------------------------OPEN----------------------------------------------------
	on CameraLister open do(
		try(
		 dataFile = openFile "cldata.dat" mode: "r"
		 print dataFile
		 CameraLister.width = (readValue dataFile)
		 CameraLister.height = (readValue dataFile)
		 SetDialogPos CameraLister (readValue dataFile)
		)catch(messagebox "Error loading history" title:"Camera Lister Error")
		
		 rollout help "Help" width:200 height:100
		 (
         label l2 "2click...select camera target" pos:[8,8]
         label l3 "click...use camera" pos:[8,32]
         label l5 "2click+shift...selest camera and target" pos:[8,56]
         label l6 "2click+crtl...toogle safe frame on/off" pos:[8,80]
         )
		getCams()
		registerRedrawViewsCallback getCams
		)
----------------------------------------CLICK-----------------------------------------------------
	on sceneCams selected sel do(
		if selLocked()  then(messagebox "You have locked selection. Unlock it." title:"Camera Lister Error")
		else(
		getCams()
		select (getNodeByName sceneCams.selected)
	    viewport.setType #view_camera
		max modify mode
		      )
		)
----------------------------------------2CLICK----------------------------------------------------
	on sceneCams doubleClicked sel do(
	     if selLocked()  then(messagebox "You have locked selection. Unlock it." title:"Camera Lister Error")
		 else(
		     try(
		         select (getNodeByName sceneCams.selected).Target
		         if keyboard.shiftPressed do(
		                                             select #((getNodeByName sceneCams.selected).Target, (getNodeByName sceneCams.selected))
		                                             )
		         if keyboard.controlPressed do(
		                                             max safeframe toggle
		                                             )
	             )catch(messagebox "Camera has no target" title:"Camera Lister Error")
	    )
	)
	
-----------------------------------------CLOSE--------------------------------------------------

	on CameraLister close do(
		 local dataFile = openFile "cldata.dat" mode: "w+"
         print sceneCams.width to: dataFile
		 print sceneCams.height to: dataFile
		 print (GetDialogPos CameraLister) to: dataFile
		)

)
createDialog CameraLister style:#(#style_resizing,#style_toolwindow,#style_sysmenu) menu:CLmenu
)